import Kit.Gobelet;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import Kit.*;
/**
 * Le Programme principale du distributeur qui est une fenetre avec tout les elements dedans.
 */
public class Distributeur extends JFrame{
    JPanel emplacementGobelet;
    
    JLabel screen;
    /**
     * Cette fonction permet d'afficher a l'ecran un texte
     * @param text texte a afficher
     */
    public void affiche(String text){
        
        screen.setText(text);
       
    }
    /**
     * Programme principale
     * @param args arguments ignore
     */
    public static void  main(String[] args){
        new Distributeur();
    }
    /**
     * Constructeur du distributeur et de la fenetre du coup
     */
    public Distributeur(){
        this.setTitle("Distributeur de boissons chaudes");//le titre
        this.setSize(500,700);//la taille de la fenetre par defaut
        
        Box b=Box.createVerticalBox();//on cree le conteneur qui aura les elements
        this.getContentPane().add(b);//on ajoute la box a la fenetre
        
        JPanel zone= new JPanel();//on cree une zone de bouton
        zone.setAlignmentX(Component.CENTER_ALIGNMENT);//cet zone sera au centre sur X
        zone.setMaximumSize(new Dimension(300,200));//on defini la taille maximal de cette zone
        b.add(zone);//et on l'ajoute a la box'
        zone.setLayout(new GridLayout(6,2));//on dit que les elements de la zone seront organiser en tableau 6ligne et 2colones
         
        for(int a=0;a<Recette.getRecettes().length;a++){//on parcours toutes nos recettes
            zone.add(new BouttonRecette(Recette.getRecettes()[a],this));//pour chaque recette on cree un bouton 
        }
        zone.add(new JLabel(""));// on ajoute un label vide pour prendre la place.
        zone.add(new BouttonSucre(0,this));//on ajoute le bouton 0g de sucre
        for(int a=2;a<5;a++){//et on cree les 3autres
            zone.add(new BouttonSucre(a,this));
        }
        
        screen=new JLabel("Selectionner une boisson ou une dose de sucre");//creation de l'ecran du distributeur
        
        screen.setAlignmentX(Component.CENTER_ALIGNMENT);//on le centre
        
        b.add(screen);//on l'ajoute a la box
        
        emplacementGobelet=new JPanel();//on cree l'endroi ou sera stoquer le gobelet
        
        b.add(emplacementGobelet);//on l'ajoute a la box
        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);//pour fermer l'application si on ferme la fenetre'
        this.setVisible(true);//on affiche la fenetre
        
    }
    /**
     * Met a l'emplacement prevu a cet effet un gobelet
     * @param g gobelet a placer
     */
    public void GiveGobelet(Gobelet g){
        emplacementGobelet.removeAll();//on elimine tout gobelet present a l'emplacement reserv'
        emplacementGobelet.add(g);//on ajoute le nouveau gobelet
        emplacementGobelet.validate();//on dit que cette zone a besoin d'etre rafraichi
        this.repaint();//on rafraichi la fenetre
        
    }
}
