package Kit;

import java.awt.Color;
/*
 * Ingredients.java
 *
 * Created on 22 octobre 2007, 21:11
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

/**
 * La class mere des ingredients contenant different type d'ingredients.
 * @author moi
 */
public class Ingredient {
    static class TypeIngrediant{//defini le type d'un ingrediant qui est un triplet nom unite et couleur
        private String nom;
        private String unite;
        private Color color;
        //construit le type et il ne devrai etre cree que par la classe ingrdient
        private TypeIngrediant(String nom,String unite, Color color){
            this.nom=nom;
            this.unite=unite;
            this.color=color;
        }
        public String toString(){//renvoi les info de type
            return ""+ unite+ " de "+nom;
        }
        public String getUnite(){//renvoi l'unite'
            return unite;
        }
        public String getNom(){//renvoi le nom
            return nom;
        }
        public Color getColor(){//retourne la couleur
            return color;
        }
        
        
        // ---- On defini chaque type dans la class TypeIngrediant ainsi il n'existera qu'une seule instance par type
        /**
         * type caf
         */
        final public static TypeIngrediant CAFE=new TypeIngrediant("Caf","g",new Color(200,200,200));
        /**
         * type chocola
         */
        final public static TypeIngrediant CHOCOLAT=new TypeIngrediant("Chocolat","g",new Color(200,0,200));
        /**
         * type lait
         */
        final public static TypeIngrediant LAIT=new TypeIngrediant("Lait","g",Color.WHITE);
        /**
         * type the
         */
        final public static TypeIngrediant THE=new TypeIngrediant("Th","g",new Color(200,200,100));
        /**
         * type eau
         */
        final public static TypeIngrediant EAU=new TypeIngrediant("Eau","l",new Color(100,100,255));
        /**
         * type sucre
         */
        final public static TypeIngrediant SUCRE=new TypeIngrediant("Sucre","g",Color.GRAY);
    }
    // dans chaque Ingredient il y a donc un type
    private TypeIngrediant tIngredient;
    //et une quantitee
    private int qte;
    
    /**
     * lorsqu'on cree un ingrediant on defini ca quantitee et son type.
     * @param nom type de l'ingrediant
     * @param qte quantitee
     */
    public Ingredient(TypeIngrediant nom,int qte) {
        this.tIngredient=nom;
        this.qte=qte;
    }
    /**
     * retournes les informations sur le contenu
     * @return info
     */
    public String toString(){
        return ""+qte+tIngredient;
    }
    /**
     * recupere la couleur de l'ingrediant defini par son type
     * @return couleur
     */
    public Color getColor(){
        return this.tIngredient.getColor();
    }
    /**
     * recupere la quantitee
     * @return qte
     */
    public int getQuantitee(){
        return qte;
    }
    /**
     * recupere le type de l'ingredient
     * @return type
     */
    public TypeIngrediant getType(){
        return tIngredient;
    }
}
