package Kit;
/*
 * Recette.java
 *
 * Created on 22 octobre 2007, 21:09
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

/**
 * Recette est la class mere des recette et en meme temps contient la liste des recettes 
 * Deplus permet aussi de definir la quantitee de sucre pour chaque recette
 * @author moi
 */
public abstract class Recette {
    //tableau definissant chaque recettes
    private static Recette recettes[] = {new Eau(),new The(),new ChocolatAuLait(),
    new Cafe(), new Cappuccino(),new Mocaccino(),new Lait()};
    private static int sucre=0;
    private String nom;
    
    /**
     * Permet de definir une quantitee de sucre pour chaque recette d'ou le static
     * @param n quantitee de sucre
     */
    static public void setSucre(int n){
        sucre=n;
    }
    /**
     * Recurpere la liste de recettes
     * @return tableau contenant toutes les recettes
     */
    static public Recette[] getRecettes(){
        return recettes;
        
    }
    /** Creates a new instance of Recette */
    Recette() {
    }
    /**
     * methode abstraite donnant le gobelet issus de cette recette
     * @return gobelet
     */
    public abstract Gobelet doRecette();
    
    Ingredient[] getSucre(int n){
        Ingredient[] ret;
        if (sucre > 0){
            ret=new Ingredient[n+1];
            ret[n]=new Ingredient(Ingredient.TypeIngrediant.SUCRE,sucre);
        }else{
            ret=new Ingredient[n];
        }
        return ret;
    }
    
    /**
     * Renvoi le nom de la recete
     * @return nom
     */
    public String toString(){
        return nom;
    }
    void setNom(String n){
        nom=n;
    }
    
}
